//+------------------------------------------------------------------+
//|                                           SHI_SilverTrendSig.mq4 |
//|          Copyright  2003, VIAC.RU, OlegVS, GOODMAN, 2005 Shurka |
//|                                                 shforex@narod.ru |
//|                                                                  |
//|                                                                  |
//| 
//+------------------------------------------------------------------+
 
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
#define  SH_BUY   1
#define  SH_SELL  -1
 
//----  
extern int     AllBars=0;//How many bars should be counted. 0 - all the bars.
extern int     Otstup=30;//Step back.
extern double  Per=9;//Period.
int            SH,NB,i,UD;
double         R,SHMax,SHMin;
double         BufD[];
double         BufU[];
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
int init()
{
   //We will write the number of the bars for which we are counting to the NB
   if (Bars<AllBars+Per || AllBars==0) NB=Bars-Per; else NB=AllBars;
   SetIndexStyle(0,DRAW_ARROW,0,1);
   SetIndexArrow(0,159);   
   SetIndexBuffer(0,BufU);   
   SetIndexStyle(1,DRAW_ARROW,0,1);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,BufD);
   return(0);
}
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
int limit;if(counted_bars>0)counted_bars--;
limit=Bars-counted_bars;

  for(int i=0;i<limit;i++)
      {

      SHMax = High[Highest(NULL,0,MODE_HIGH,Per,SH)];
      SHMin = Low[Lowest(NULL,0,MODE_LOW,Per,SH)];
      if (Close[SH]<SHMin+(SHMax-SHMin)*Otstup/100 && UD!=SH_SELL) {
         BufU[SH]=Low[SH]-iATR(NULL,0,14,SH); UD=SH_SELL; 
      }
      if (Close[SH]>SHMax-(SHMax-SHMin)*Otstup/100 && UD!=SH_BUY){
         BufD[SH]=High[SH]+iATR(NULL,0,14,SH); UD=SH_BUY; 
      }
   }
   return(0);
}